from abaqusConstants import *
from abaqus import *
aModel=mdb.models['3D_Rad']
aAss=aMode.rootAsembly
aPart=aModel.parts['Mesh']
aSet=aAss.sets['Set-1']
aInst=aAss.instances['Mesh-1']
for eachnode in aSet.nodes:
	theta=eachnode.coordinates[1]/Radius
	newcoord1=eachnode.coordinates[0]
	newcoord2=(Radius-eachnode.coordinates[2])*cos(theta)
	newcoord3=(Radius-eachnode.coordinates[2])*sin(theta)
	aPart.editNode(nodes=eachnode,coordinate1=newcoord1,coordinate2=newcoord2,
		coordinate3=newcoord3)